## didder 1.3.0

=== Makefile ===
GITV  != git describe --tags
GITC  != git rev-parse --verify HEAD
SRC   != find . -type f -name '*.go' ! -name '*_test.go'
TEST  != find . -type f -name '*_test.go'
DATEC != date +'%B %d, %Y'

PREFIX  ?= /usr/local
VERSION ?= $(GITV)
COMMIT  ?= $(GITC)
BUILDER ?= Makefile
DATE    ?= $(DATEC)

GO      := go
INSTALL := install
RM      := rm
SED     := sed
PANDOC  := pandoc
GZIP    := gzip
MANDB   := mandb
CP      := cp

didder: go.mod go.sum $(SRC)
	GO111MODULE=on CGO_ENABLED=0 $(GO) build -o $@ -ldflags="-s -w -X main.version=$(VERSION) -X main.commit=$(COMMIT) -X main.builtBy=$(BUILDER)"

.PHONY: clean
clean:
	$(RM) -f didder

.PHONY: man
man:
	$(PANDOC) didder.1.md -s -t man -o didder.1
	$(SED) -i 's/VERSION/$(VERSION)/g' didder.1
	$(SED) -i 's/DATE/$(DATE)/g' didder.1
	$(CP) didder.1.md MANPAGE.md
	$(SED) -i 's/VERSION/$(VERSION)/g' MANPAGE.md
	$(SED) -i 's/DATE/$(DATE)/g' MANPAGE.md
	$(SED) -i '1s/^/<!-- DO NOT EDIT, AUTOMATICALLY GENERATED, EDIT dither.1.md INSTEAD -->\n/' MANPAGE.md
	$(SED) -i 's/:   /\n/g' MANPAGE.md
	$(SED) -i 's/    //g' MANPAGE.md
	$(SED) -i 's/^\[/    \[/g' MANPAGE.md
	$(SED) -i 's/\\$$//g' MANPAGE.md

.PHONY: install
install: didder
	$(INSTALL) -d $(PREFIX)/bin/
	$(INSTALL) -m 755 didder $(PREFIX)/bin/didder
	$(GZIP) -c didder.1 > /usr/share/man/man1/didder.1.gz
	$(MANDB)

.PHONY: uninstall
uninstall:
	$(RM) -f $(PREFIX)/bin/didder

# Development helpers

.PHONY: fmt
fmt:
	$(GO) fmt ./...

=== debian/changelog ===
didder (1.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1100090)

 -- Nicolas Peugnet <nicolas@club1.fr>  Wed, 12 Mar 2025 21:35:39 +0100

=== debian/control ===
Source: didder
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Nicolas Peugnet <nicolas@club1.fr>,
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any,
               golang-github-disintegration-imaging-dev,
               golang-github-makeworld-the-better-one-dither-dev,
               golang-github-urfave-cli-v2-dev,
               golang-golang-x-image-dev,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/didder
Vcs-Git: https://salsa.debian.org/go-team/packages/didder.git
Homepage: https://github.com/makew0rld/didder
XS-Go-Import-Path: github.com/makeworld-the-better-one/didder

Package: didder
Section: graphics
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Static-Built-Using: ${misc:Static-Built-Using}
Description: Extensive, fast, and accurate command-line image dithering tool
 didder is an extensive, fast, and accurate command-line image dithering
 tool. It is designed to work well for both power users as well as
 pipeline scripting. It is backed by the author's dithering library
 (https://github.com/makew0rld/dither), and is unique in its correctness
 and variety of dithering algorithms. It provides many options, while
 being correct (linearizing the image, weighting channels by luminance).
 .
 Types of dithering supported
 .
  * Random noise (in grayscale and RGB)
  * Ordered Dithering
    * Bayer matrix of any size (as long as dimensions are powers of two)
    * Clustered-dot - many different preprogrammed matrices
    * Some unusual horizontal or vertical line matrices
    * Yours? You can provide your own ordered dithering matrix in JSON format
  * Error diffusion dithering
    * Simple 2D
    * Floyd-Steinberg, False Floyd-Steinberg
    * Jarvis-Judice-Ninke
    * Atkinson
    * Stucki
    * Burkes
    * Sierra/Sierra3, Sierra2, Sierra2-4A/Sierra-Lite
    * Steven Pigeon (https://hbfs.wordpress.com/2013/12/31/dithering/)
    * Yours? You can provide your own error diffusion matrix in JSON format
 .
 Features
 .
  * Set palette using RGB tuples, hex codes, number 0-255 (grayscale), or
    SVG color names (https://www.w3.org/TR/SVG11/types.html#ColorKeywords)
  * Optionally recolor image with a different palette after dithering
  * Set dithering strength
  * Image is automatically converted to grayscale if palette is grayscale
  * Force image to grayscale with --grayscale
  * Change image saturation, brightness, or contrast before dithering
  * Read EXIF rotation tags by default (disabled with --no-exif-rotation)
  * Downscale image before dithering, keeping aspect ratio
  * Upscale image after dithering, without producing artifacts
  * Supports input image of types JPEG, GIF (static), PNG, BMP, TIFF
  * Output to PNG or GIF
  * Process multiple images with one command
  * Combine multiple images into an animated GIF
  * Uses all CPU cores when possible
  * Support images with transparency (alpha channel is kept the same)

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

LDFLAGS := -X main.version=$(DEB_VERSION_UPSTREAM)
LDFLAGS += -X main.commit=$(DEB_VERSION)
LDFLAGS += -X main.builtBy=dh-golang

%:
	dh $@ --builddirectory=_build --buildsystem=golang

override_dh_auto_build:
	dh_auto_build --builddirectory=_build --buildsystem=golang -- -ldflags '$(LDFLAGS)'

override_dh_auto_install:
	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/makew0rld/didder/tags .*/v?(\d\S*)\.tar\.gz debian
